/* 	Copyright (c) 1992 NeXT Computer, Inc.  All rights reserved. 
 *
 * CirrusLogicGD754X.h -- interface for CirrusLogicGD754X driver.
 *
 */


#import <driverkit/IOSVGADisplay.h>
#import "SVGAConstants.h"
#import "../clio/CirrusLogicGD754XMode.h"

@interface CirrusLogicGD754X_SVGA:IOSVGADisplay
{
    int readPlaneMask;
    int writePlaneMask;
    int readSegment;
    int writeSegment;
    int selectedMode;

    /* The physical address of framebuffer. */
    unsigned long videoRamAddress;
	
	struct {		
		long setReadSegment;
		long setWriteSegment;
	}		segmentCounters[16];
	struct {
		long setReadPlane;
		long setWritePlane;
	}		planeCounters[4];
	struct {
		long savePlaneAndSegment;
		long restorePlaneAndSegment;
		long enterSVGAMode;
		long reverToVGAMode;
	}		counters;
}

// public methods:
	-(void)setReadSegment:(unsigned char)segmentNum;
	-(void)setWriteSegment:(unsigned char)segmentNum;
	-(void)setReadPlane:(unsigned char)planeNum;
	-(void)setWritePlane:(unsigned char)planeNum;
	-(void)savePlaneAndSegmentSettings;
	-(void)restorePlaneAndSegmentSettings;
	-(void)enterSVGAMode;
	-(void)revertToVGAMode;
	
// private methods:
	-(void)_selectMode:(const char*)dispModeStr;
	
	/*
		Actually, call only _SVGASetAllRegistersForMode, it will take care
		to call these ones.
	*/
	-(void)_SVGASetGeneralRegisters:
							(const SVGAIndexValuePair*)regInfo;
	-(void)_SVGASetSequencerRegisters:
							(const SVGAIndexValuePair*)regInfo;
	-(void)_SVGASetCrtControllerRegisters:
							(const SVGAIndexValuePair*)regInfo;
	-(void)_SVGASetGraphicsControllerRegisters:
							(const SVGAIndexValuePair*)regInfo;
	-(void)_SVGASetAttributeControllerRegisters:
							(const SVGAIndexValuePair*)regInfo;

	-(void)_SVGASetAllRegistersForMode:(const CirrusLogicGD754XMode*)mode;
	-(void)clearScreen;
	
@end
