/* 	Copyright (c) 1992 NeXT Computer,Inc.  All rights reserved. 
 *
 *  CirrusLogicGD754X_SVGA.m
 *
 */


#import "CirrusLogicGD754X_SVGA.h"
#import <driverkit/i386/IOEISADeviceDescription.h>
#import <driverkit/i386/displayRegisters.h>
#import <driverkit/devsw.h> 
#import <driverkit/kernelDriver.h>
#import <kernserv/prototypes.h>
#import <kernserv/kern_server_types.h>
#import <stdio.h>
#import <string.h>
#import <sys/errno.h>
#import <sys/types.h>
#import <sys/buf.h>
#import <sys/conf.h>
#import <sys/uio.h>

#import "GD754X_800x600x2x60hz.h"
#import "../clio/clio.h"
#import "Version.h"

#define DEBUG
#define DEMO

#define	MIN(a,b) (((a)<(b))?(a):(b))
#define isdigit(a) (('0'<=(a))&&((a)<='9'))
#define isupper(a) (('A'<=(a))&&((a)<='Z'))
#define tolower(a) ((a)-'A'+'a')

// Framebuffer characteristics.
#define FRAMEBUFFER_ADDRESS ((void *)0xa0000)

@implementation CirrusLogicGD754X_SVGA

#define DEBUG_DISPLAY

	static void display(char* frame,int pos,int value)		
	{
#ifdef DEBUG_DISPLAY
		static unsigned char gentab[10][10]={
			{0xFF,0xEF,0xD7,0xBB,0xBB,0xBB,0xD7,0xEF,0xFF,0xFF},//cc_zero
			{0xFF,0xEF,0xCF,0xEF,0xEF,0xEF,0xEF,0xEF,0xFF,0xFF},//cc_one
			{0xFF,0xC7,0xBB,0xFB,0xE7,0xDF,0xBF,0x83,0xFF,0xFF},//cc_two
			{0xFF,0x83,0xFB,0xF7,0xE7,0xFB,0xBB,0xC7,0xFF,0xFF},//cc_three
			{0xFF,0xF7,0xE7,0xD7,0xB7,0x83,0xF7,0xF7,0xFF,0xFF},//cc_four
			{0xFF,0x83,0xBF,0x87,0xFB,0xFB,0xBB,0xC7,0xFF,0xFF},//cc_five
			{0xFF,0xE7,0xDF,0xBF,0x87,0xBB,0xBB,0xC7,0xFF,0xFF},//cc_six
			{0xFF,0x83,0xFB,0xF7,0xEF,0xDF,0xDF,0xDF,0xFF,0xFF},//cc_seven
			{0xFF,0xC7,0xBB,0xBB,0xC7,0xBB,0xBB,0xC7,0xFF,0xFF},//cc_eight
			{0xFF,0xC7,0xBB,0xBB,0xC3,0xFB,0xFB,0xC7,0xFF,0xFF} //cc_nine
		};
		int rowBytes=100;
		char* base=(char*)frame;
		int j;
		unsigned char tmp;
		unsigned char plane;
		unsigned char writePlaneMask;
		
		base+=rowBytes*580+pos;
		value%=10;


		writePlaneMask=IOReadRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK);
		for(plane=1;plane<8;plane<<=1){
			tmp=IOReadRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK);
			tmp=(tmp&(~(SEQ_AT_EM3|SEQ_AT_EM2|SEQ_AT_EM1|SEQ_AT_EM0)))|1;
			IOWriteRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK,tmp);
			for(j=0;j<10;j++){
				base[rowBytes*j]=gentab[value][j];
			}
		}
		IOWriteRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK,writePlaneMask);
#endif
	}//display;

/*
	for(j=0;j<10;j++){
		for(i=0;i<8;i++){
			int k=rowBytes*j+(i>>2);
			base[k]=((~(0xc0>>((i&3)*2)))&(base[k]))
				|(((gentab[value][j])&(0x80>>i))==0?0:(0xc0>>((i&3)*2)));
		}
	}

*/



// rowbytes =
//	#bytes/scanline =
//	((pixels/line) * (2 bits/pixel) * (byte/8 bits)) =
//	(pixel width / 4)

	static const IODisplayInfo modeTable[]={
#define defaultMode (0)
		{
			// CirrusLogicGD754X 800 x 600 x 2 x 60hz
			800,										// width,
			600,										// height,
			800,										// totalWidth,
			200,										// rowbytes,
			60,											// refreshRate,
			0,											// frameBuffer,
			IO_2BitsPerPixel,							// bitsPerPixel,
			IO_OneIsBlackColorSpace,					// colorSpace,
			"WW",										// pixelEncoding,
			0,											// flags,
			(void *)&CirrusLogicGD754X_800x600x2x60hz	// parameters
		}
/*
		{
			// CirrusLogicGD754X 800 x 600 x 8 x 60hz
			800,										// width,
			600,										// height,
			800,										// totalWidth,
			200,										// rowbytes,
			60,											// refreshRate,
			0,											// frameBuffer,
			IO_8BitsPerPixel,							// bitsPerPixel,
			IO_OneIsBlackColorSpace,					// colorSpace,
			"WWWWWWWW",									// pixelEncoding,
			0,											// flags,
			(void *)&CirrusLogicGD754X_800x600x8x60hz	// parameters
		}	
		/* Add more modes here. */
	};

#define modeTableCount  (sizeof(modeTable) / sizeof(IODisplayInfo))


	
// Private methods:
	
	static void SetBrightness(unsigned int level)
		/*
			Sets the screen's brightness.  This implementation
			uses a fixed gamma value.  It sets the palette
			values according to the brightness level.
		*/
	{
		unsigned char val;
	
		val=EV_SCALE_BRIGHTNESS(level,WHITE_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_AWMR,(unsigned char)WHITE_INDEX);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
	
		val=EV_SCALE_BRIGHTNESS(level,LIGHT_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_AWMR,(unsigned char)LIGHT_GRAY_INDEX);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
	
		val=EV_SCALE_BRIGHTNESS(level,DARK_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_AWMR,(unsigned char)DARK_GRAY_INDEX);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
	
		val=EV_SCALE_BRIGHTNESS(level,BLACK_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_AWMR,(unsigned char)BLACK_INDEX);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
		outb(WRIT_COLR_PEL_DATA,val);
	}//SetBrightness;
	
	
	static void setColorMapToLinearMonochrome(void)
		/*
			Sets the color map to linear monochrome by zeroing
			out the entire table,then setting the first four
			palette values correctly.
		*/
	{
		int i;
	
		for (i=0; i < 256; i++) {
			outb(WRIT_COLR_PEL_AWMR,i);
			outb(WRIT_COLR_PEL_DATA,0x00);
			outb(WRIT_COLR_PEL_DATA,0x00);
			outb(WRIT_COLR_PEL_DATA,0x00);
		}
		outb(WRIT_COLR_PEL_AWMR,WHITE_INDEX);
		outb(WRIT_COLR_PEL_DATA,WHITE_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,WHITE_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,WHITE_PALETTE_VALUE);
		
		outb(WRIT_COLR_PEL_AWMR,LIGHT_GRAY_INDEX);
		outb(WRIT_COLR_PEL_DATA,LIGHT_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,LIGHT_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,LIGHT_GRAY_PALETTE_VALUE);
		
		outb(WRIT_COLR_PEL_AWMR,DARK_GRAY_INDEX);
		outb(WRIT_COLR_PEL_DATA,DARK_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,DARK_GRAY_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,DARK_GRAY_PALETTE_VALUE);
		
		outb(WRIT_COLR_PEL_AWMR,BLACK_INDEX);
		outb(WRIT_COLR_PEL_DATA,BLACK_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,BLACK_PALETTE_VALUE);
		outb(WRIT_COLR_PEL_DATA,BLACK_PALETTE_VALUE);
	}//setColorMapToLinearMonochrome;
	
	static id myself;

	int clOpen(dev_t dev)
	{
		return(0);
	}//clOpen;
	
	
	int clClose(dev_t dev)
	{
		return(0);
	}//clClose;
	
	
	int clRead(dev_t dev, struct uio *uiop)
	{
		return(0);
	}//clRead;
	
	
	int clWrite(dev_t dev, struct uio *uiop)
	{
		return(0);
	}//clWrite;
	
	
	int countpairs(SVGAIndexValuePair* pairs,int from)
	{
		while((from<CLIO_MAXPAIRS)&&(pairs[from].index!=-1)){
			from++;
		}
		return(from+1);
	}//countpairs;
	
	
	int clIoctl(dev_t dev,int cmd,caddr_t data,int flag)
	{
			int error=0;
			id  cl=myself;
			SVGAIndexValuePair buffer[CLIO_MAXPAIRS];
			char               name[256];
			CirrusLogicGD754XMode* mode;
			int size;
			int next;
			clio_inoutb_t*  param;
			clio_display_t* disp;
			IODisplayInfo*  disinfo;
			
		switch(cmd){
		case CLIOCSETBRIGHT:
			[cl setBrightness:*(int*)data token:0];
			break;
#ifdef DEBUG
		case CLIOCOUTB:
			param=(clio_inoutb_t*)data;
			outb(param->port,param->byte);
			break;
		case CLIOCINB:
			param=(clio_inoutb_t*)data;
			param->byte=inb(param->port);
			break;
		case CLIOCSETREG:
			
			mode=(CirrusLogicGD754XMode*)data;
			size=sizeof(buffer);
			next=0;


			if(copyin(mode->name,name,sizeof(name))!=0){
				error=EFAULT;
				break;
			}

			if(copyin(mode->generalRegisters,&(buffer[next]),size)!=0){
				error=EFAULT;
				break;
			}
			mode->generalRegisters=&(buffer[next]);
			next=countpairs(buffer,next);
			size=sizeof(buffer)-next*sizeof(SVGAIndexValuePair);
			if(size<=0){
				error=E2BIG;
				break;
			}
			
			if(copyin(mode->sequencerRegisters,&(buffer[next]),size)!=0){
				error=EFAULT;
				break;
			}
			mode->sequencerRegisters=&(buffer[next]);
			next=countpairs(buffer,next);
			size=sizeof(buffer)-next*sizeof(SVGAIndexValuePair);
			if(size<=0){
				error=E2BIG;
				break;
			}
			
			if(copyin(mode->crtControllerRegisters,&(buffer[next]),size)!=0){
				error=EFAULT;
				break;
			}
			mode->crtControllerRegisters=&(buffer[next]);
			next=countpairs(buffer,next);
			size=sizeof(buffer)-next*sizeof(SVGAIndexValuePair);
			if(size<=0){
				error=E2BIG;
				break;
			}
			
			if(copyin(mode->graphicsControllerRegisters,
					&(buffer[next]),size)!=0){
				error=EFAULT;
				break;
			}
			mode->graphicsControllerRegisters=&(buffer[next]);
			next=countpairs(buffer,next);
			size=sizeof(buffer)-next*sizeof(SVGAIndexValuePair);
			if(size<=0){
				error=E2BIG;
				break;
			}
			
			if(copyin(mode->attributeControllerRegisters,
					&(buffer[next]),size)!=0){
				error=EFAULT;
				break;
			}
			mode->attributeControllerRegisters=&(buffer[next]);
			next=countpairs(buffer,next);
			size=sizeof(buffer)-next*sizeof(SVGAIndexValuePair);
			if(size<=0){
				error=E2BIG;
				break;
			}
			
			[cl _SVGASetAllRegistersForMode:mode];
			break;
		case CLIOCDISPLAY:
			disp=(clio_display_t*)data;
			disinfo=[cl displayInfo];
			display(disinfo->frameBuffer-10*disinfo->rowBytes,
								disp->pos,disp->value);
			break;
#endif
		default:
			error=EINVAL;
			break;
		}
		IOSetUNIXError(error);
		return(error);
	}//clIoctl;
	
	
	extern int		nulldev();
	extern int		nodev();

	
	-(void)_addUnixHooks:(id)deviceDescription
	{
		myself=self;
		[[self class] addToCdevswFromDescription:deviceDescription
			open:(IOSwitchFunc)clOpen
			close:(IOSwitchFunc)clClose
			read:(IOSwitchFunc)clRead
			write:(IOSwitchFunc)clWrite
			ioctl:(IOSwitchFunc)clIoctl
			stop:(IOSwitchFunc)nodev
			reset:(IOSwitchFunc)nulldev
			select:(IOSwitchFunc)nulldev
			mmap:(IOSwitchFunc)nodev
			getc:(IOSwitchFunc)nodev
			putc:(IOSwitchFunc)nodev ];
		IOLog("%s: Unix Hooks added. Character Major=%d\n",
					[self name],[[self class] characterMajor]);
	}//_addUnixHooks;
	
	
	static BOOL compatibleColorSpaces(IOColorSpace a, IOColorSpace b)
	{
		return(((a<2)&&(b<2))||(a==b));
	}//compatibleColorSpaces;
	
	
	static BOOL getWordFromInto(const char* str,int* pos,char* word)
	{
			int cur=(*pos);
			
		while(str[cur]==' '){
			cur++;
		}
		if(str[cur]=='\0'){
			(*pos)=cur;
			return(NO);
		}else{
			while((str[cur]!=' ')&&(str[cur]!='\0')){
				(*word++)=str[cur++];
			}
			(*word)='\0';
			(*pos)=cur;
			return(YES);
		}
	}//getWordFromInto;
	
	
	static int atoi(const char* str)
	{
		int	r=0;
		int s=1;
		while(*str==' '){
			str++;
		}
		switch(*str){
		case '-':
			s=-1;
			// fall.
		case '+':
			str++;
			// fall.
		default:
			break;
		}
		while(isdigit(*str)){
			r=r*10+(*str)-'0';
			str++;
		}
		return(r*s);
	}//atoi;
	
	
	static void strtolower(char* str)
	{
		while((*str)!='\0'){
			if(isupper(*str)){
				(*str)=tolower(*str);
			}
			str++;
		}
	}//strtolower;
	
	
	-(void)parseDisplayModeString:(const char*)dispModeStr 
				into:(IODisplayInfo*)displayInfo
	{
			int	pos;
			char buffer[64];
			char* bpp;
			
		displayInfo->width=0;
		displayInfo->height=0;
		displayInfo->refreshRate=0;
		displayInfo->bitsPerPixel=0;
		displayInfo->colorSpace=0xff;

		pos=0;
		while(getWordFromInto(dispModeStr,&pos,buffer)){
			strtolower(buffer);
			// Height: 600 Width: 800 Refresh: 60Hz ColorSpace: BW:2
			if(strcmp(buffer,"height:")==0){
				if(getWordFromInto(dispModeStr,&pos,buffer)){
					displayInfo->height=atoi(buffer);
				}
			}else if(strcmp(buffer,"width:")==0){
				if(getWordFromInto(dispModeStr,&pos,buffer)){
					displayInfo->width=atoi(buffer);
				}
			}else if(strcmp(buffer,"refresh:")==0){
				if(getWordFromInto(dispModeStr,&pos,buffer)){
					displayInfo->refreshRate=atoi(buffer);
				}
			}else  if(strcmp(buffer,"colorspace:")==0){
				if(getWordFromInto(dispModeStr,&pos,buffer)){
					strtolower(buffer);
					bpp=0;
					if(strncmp(buffer,"rgb",3)==0){
						displayInfo->colorSpace=IO_RGBColorSpace;
						bpp=strchr(buffer,'/');
					}else if(strncmp(buffer,"cmyk",4)==0){
						displayInfo->colorSpace=IO_CMYKColorSpace;
						bpp=strchr(buffer,'/');
					}else if(strncmp(buffer,"bw",2)==0){
						displayInfo->colorSpace=IO_OneIsBlackColorSpace;
						bpp=strchr(buffer,':');
					}
					if(bpp!=0){
						int nbpp=atoi(bpp+1);
						switch(nbpp){
						case 2:
							displayInfo->bitsPerPixel=IO_2BitsPerPixel;
							break;
						case 8:
							displayInfo->bitsPerPixel=IO_8BitsPerPixel;
							break;
						case 16:
							displayInfo->bitsPerPixel=IO_15BitsPerPixel;
							break;
						case 24:
							displayInfo->bitsPerPixel=IO_24BitsPerPixel;
							break;
						default:
							break;
						}
					}
				}
			}
		}
	}//parseDisplayModeString:into:;


	-(void)_selectMode:(const char*)dispModeStr
		/*
			During initialization,this selects the configured mode
			and sets the display info accordingly.
		*/
	{
		selectedMode=[self selectMode:modeTable count:modeTableCount];	
		if(selectedMode<0){
				int           i;
				IODisplayInfo wantedDisplayInfo;
			
			[self parseDisplayModeString:dispModeStr into:&wantedDisplayInfo];
			// Height: 600 Width: 800 Refresh: 60Hz ColorSpace: BW:2
			selectedMode=defaultMode;
			i=0;
			while(i<modeTableCount){
				if((wantedDisplayInfo.width==modeTable[i].width)
				&&(wantedDisplayInfo.height==modeTable[i].height)
				&&(wantedDisplayInfo.refreshRate==modeTable[i].refreshRate)
				&&(wantedDisplayInfo.bitsPerPixel==modeTable[i].bitsPerPixel)
				&&(compatibleColorSpaces(wantedDisplayInfo.colorSpace,
										modeTable[i].colorSpace))){
					selectedMode=i;
					IOLog("%s: Found a matching mode: using %s.\n",
						[self name],((CirrusLogicGD754XMode*)
							modeTable[selectedMode].parameters)->name);
					i=modeTableCount;
				}else{
					i++;
				}
			}
		}
		(*[self displayInfo])=modeTable[selectedMode];
	}//_selectMode;
	
	
	
	-(void)_SVGASetGeneralRegisters:
							(const SVGAIndexValuePair*)regInfo
		/*
			Set all the general registers for the given mode.
		*/
	{
		while(regInfo->index!=-1){
			outb(WRIT_EIDR_GEN_MISC_OP,regInfo->value);
			regInfo++;
		}
	}//_SVGASetGeneralRegistersForMode:;
	
	
	-(void)_SVGASetSequencerRegisters:
							(const SVGAIndexValuePair*)regInfo
		/*
			Set all the sequencer registers for the given mode.
		*/
	{
		while(regInfo->index!=-1){
			IOWriteRegister(EIDR_SEQ_ADDR,(char)(regInfo->index),
							regInfo->value);
			regInfo++;
		}
	}//_SVGASetSequencerRegisters:;
	
	
	-(void)_SVGASetCrtControllerRegisters:
							(const SVGAIndexValuePair*)regInfo
		/*
			Set all the crt controller registers for the given mode.
		*/
	{
		while(regInfo->index!=-1){
			IOWriteRegister(COLR_CRT_ADDR,(char)(regInfo->index),
							regInfo->value);
			regInfo++;
		}
	}//_SVGASetCrtControllerRegisters:;
	
	
	
	-(void)_SVGASetGraphicsControllerRegisters:
							(const SVGAIndexValuePair*)regInfo
		/*
			Set all the graphics controller registers for the given mode.
		*/
	{
		while(regInfo->index!=-1){
			IOWriteRegister(EIDR_GCR_ADDR,(char)(regInfo->index),
							regInfo->value);
			regInfo++;
		}
	}//_SVGASetGraphicsControllerRegisters:;
	
	
	-(void)_SVGASetAttributeControllerRegisters:
							(const SVGAIndexValuePair*)regInfo
		/*
			Set all the attribute controller registers for the given mode.
		*/
	{
		while(regInfo->index!=-1){
				char tmpi;
			inb(READ_COLR_GEN_IN_ST_1);
			tmpi=inb(READ_TOGL_ACR_ADDR);
			tmpi&=~ACR_MSK;
			tmpi|=(regInfo->index & ACR_MSK);
			outb(WRIT_TOGL_ACR_ADDR,tmpi);
			outb(WRIT_TOGL_ACR_DATA,regInfo->value);
			regInfo++;
		}
	}//_SVGASetAttributeControllerRegisters:;
		
	
	-(void)_SVGASetAllRegistersForMode:(const CirrusLogicGD754XMode*)mode
	{
		IOLog("%s: Setting registers for mode %s\n",[self name], mode->name);
#ifdef DEBUG_DUMP_ALL_REG
			int i;
		IOLog("%s: GENERAL registers\n",[self name]);
		i=0;
		while(mode->generalRegisters[i].index>=0){
			IOLog("%s:      %04x  %02x\n",[self name],
					mode->generalRegisters[i].index,
					mode->generalRegisters[i].value);
			i++;
		}
		IOLog("%s: SEQUENCER registers\n",[self name]);
		i=0;
		while(mode->sequencerRegisters[i].index>=0){
			IOLog("%s:      %04x  %02x\n",[self name],
					mode->sequencerRegisters[i].index,
					mode->sequencerRegisters[i].value);
			i++;
		}
		IOLog("%s: CRT registers\n",[self name]);
		i=0;
		while(mode->crtControllerRegisters[i].index>=0){
			IOLog("%s:      %04x  %02x\n",[self name],
					mode->crtControllerRegisters[i].index,
					mode->crtControllerRegisters[i].value);
			i++;
		}
		IOLog("%s: GRAPHIC registers\n",[self name]);
		i=0;
		while(mode->graphicsControllerRegisters[i].index>=0){
			IOLog("%s:      %04x  %02x\n",[self name],
					mode->graphicsControllerRegisters[i].index,
					mode->graphicsControllerRegisters[i].value);
			i++;
		}
		IOLog("%s: ATTRIBUTES registers\n",[self name]);
		i=0;
		while(mode->attributeControllerRegisters[i].index>=0){
			IOLog("%s:      %04x  %02x\n",[self name],
					mode->attributeControllerRegisters[i].index,
					mode->attributeControllerRegisters[i].value);
			i++;
		}
		
#endif
		[self _SVGASetGeneralRegisters:mode->generalRegisters];
		[self _SVGASetSequencerRegisters:mode->sequencerRegisters];
		[self _SVGASetCrtControllerRegisters:mode->crtControllerRegisters];
		[self _SVGASetGraphicsControllerRegisters:
									mode->graphicsControllerRegisters];
		[self _SVGASetAttributeControllerRegisters:
									mode->attributeControllerRegisters];
	}//_SVGASetAllRegistersForMode:;
	

	-(void)_initCounters
	{
		int i;
		for(i=0;i<16;i++){
			segmentCounters[i].setReadSegment=0;
			segmentCounters[i].setWriteSegment=0;
		}
		for(i=0;i<16;i++){
			planeCounters[i].setReadPlane=0;
			planeCounters[i].setWritePlane=0;
		}
		counters.savePlaneAndSegment=0;
		counters.restorePlaneAndSegment=0;
		counters.enterSVGAMode=0;
		counters.reverToVGAMode=0;
	}//_initCounters;
	
	
// public methods:	
	
	-(void)setReadSegment:(unsigned char)segmentNum
		/*
			Select which 64K segment we intend to read from.
		*/
	{
		outb(0x03ce,0x09);
		outb(0x03cf,(segmentNum<<4));
		
		display([self displayInfo]->frameBuffer,10+segmentNum,segmentNum);
		if(segmentCounters[segmentNum].setReadSegment==0){
			IOLog("%s: setReadSegment[%d]\n",[self name],segmentNum);
		}
		segmentCounters[segmentNum].setReadSegment++;
	}//setReadSegment:;
	
	
	-(void)setWriteSegment:(unsigned char)segmentNum
		/*
			Select which 64K segment we intend to write to.
		*/
	{
		outb(0x03ce,0x09);
		outb(0x03cf,(segmentNum<<4));
		
		display([self displayInfo]->frameBuffer,20+segmentNum,segmentNum);
		if(segmentCounters[segmentNum].setWriteSegment==0){
			IOLog("%s: setWriteSegment[%d]\n",[self name],segmentNum);
		}
		segmentCounters[segmentNum].setWriteSegment++;
	}//setWriteSegment:;
	
	
	-(void)setReadPlane:(unsigned char)planeNum
		/*
			Select which of 4 bit planes to read from in planar
			modes - only one plane can be active at a time.
		*/
	{
			char tmp;
	
		display([self displayInfo]->frameBuffer,30+planeNum,planeNum);

		tmp=IOReadRegister(EIDR_GCR_ADDR,GCR_AT_READ_MAPS);
		tmp&=(~GCR_AT_RMS);
		tmp|=(planeNum&GCR_AT_RMS);
		IOWriteRegister(EIDR_GCR_ADDR,GCR_AT_READ_MAPS,tmp);

		if(planeCounters[planeNum].setReadPlane==0){
			IOLog("%s: setReadPlane[%d]\n",[self name], planeNum);
		}
		planeCounters[planeNum].setReadPlane++;
	}//setReadPlane:;
	
	
	-(void)setWritePlane:(unsigned char)planeNum
		/*
			Select one of 4 bit planes to write to in planar modes.
			Although more than one plane can be active at a time,
			this routine only allows access to 1 plane at a time.
		*/
	{
			char tmp;
			char plane;
	
		display([self displayInfo]->frameBuffer,40+planeNum,planeNum);

		// Convert plane num to bit enable:
		plane=1<<(planeNum&0x03);
		// Select plane we are writing to:
		tmp=IOReadRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK);
		tmp&=(~(SEQ_AT_EM3|SEQ_AT_EM2|SEQ_AT_EM1|SEQ_AT_EM0));
		tmp|=plane;
		IOWriteRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK,tmp);

		if(planeCounters[planeNum].setWritePlane==0){
			IOLog("%s: setWritePlane[%d]\n",[self name], planeNum);
		}
		planeCounters[planeNum].setWritePlane++;
	}//setWritePlane:;
	
	
	-(void)savePlaneAndSegmentSettings
		/*
			Saves the current plane and segment settings.
			This is not a stack push,so we can only save/
			restore one group of settings at a time.
		*/
	{
		writePlaneMask=IOReadRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK);
		readPlaneMask=IOReadRegister(EIDR_GCR_ADDR,GCR_AT_READ_MAPS);
		outb(0x3ce,0x09);
		readSegment=((inb(0x3cf))>>4);
		writeSegment=readSegment;
		display([self displayInfo]->frameBuffer,5,9);
	}//savePlaneAndSegmentSettings;
	
	
	-(void)restorePlaneAndSegmentSettings
		/*
			Restores the current plane and segment settings.
			This is not a stack pop,so we can only save/
			restore one group of settings at a time.
		*/
	{
		IOWriteRegister(EIDR_SEQ_ADDR,SEQ_AT_MPK,writePlaneMask);
		IOWriteRegister(EIDR_GCR_ADDR,GCR_AT_READ_MAPS,readPlaneMask);
		outb(0x3ce,0x09);
		outb(0x3cf,(readSegment<<4));
		display([self displayInfo]->frameBuffer,5,8);
	}//restorePlaneAndSegmentSettings;
	
	
	-(void)clearScreen
	{
			IODisplayInfo* displayInfo;
			int            totalScreenBytes;
			int            bytesLeftToClear;
			int            writeSegmentToClear;
			unsigned char  clear;
			unsigned char* block;

		displayInfo=[self displayInfo];
		totalScreenBytes=displayInfo->rowBytes*displayInfo->height;
		bytesLeftToClear=totalScreenBytes;
		writeSegmentToClear=0;
		clear=0;
		while(bytesLeftToClear>0){
			int i=MIN(0x10000,bytesLeftToClear);
			[self setWriteSegment:writeSegmentToClear];
			block=displayInfo->frameBuffer;
			while(i>0){
				block[--i]=clear;
			}
			bytesLeftToClear-=0x10000;
			writeSegmentToClear++;
		}
	
		[self setWriteSegment:0];
		[self setWritePlane:0];
	}//clearScreen;
	
	
	-(void)enterSVGAMode
		/*
			Put the display into SVGA mode selectedMode. This
			typically happens when the window server starts running.
			We set up all the registers necessary for the given
			mode and then clear the screen.
		*/
	{
			
		[self _SVGASetAllRegistersForMode:modeTable[selectedMode].parameters];
		setColorMapToLinearMonochrome();
		[self clearScreen];
#ifdef DEBUG
		display([self displayInfo]->frameBuffer,9,9);
#endif
		// re-enable timing sequencer:
		IOWriteRegister(EIDR_SEQ_ADDR,SEQ_AT_CRS,0x00);
	}//enterSVGAMode;
	

	-(void)revertToVGAMode
		/*
			Put the display into VGA mode. This typically happens
			when SoftPC enters full-screen mode.  We set up all the
			registers necessary for the given mode.
		*/
	{
		display([self displayInfo]->frameBuffer,6,8);
		outb(WRIT_EIDR_GEN_MISC_OP,0xE3);
	}//revertToVGAMode;
	

// IODevice methods:

	- initFromDeviceDescription:deviceDescription
		/*
			Initialize the current instance as
			per the deviceDescription.  Most importantly,this
			includes selecting the mode and mapping the frame buffer.
		*/
	{
		IODisplayInfo*               displayInfo;
		const IORange*               range;
		const CirrusLogicGD754XMode* mode;
		IOConfigTable*               confTab;
		const char*                  dispModeStr;

		if ([super initFromDeviceDescription:deviceDescription]==nil){
#ifdef DEBUG
		IOLog("%s: DEBUG [super init...] could not initialize\n",[self name]);
#endif
			return([super free]);
		}

		IOLog("%s: Cirrus Logic GD754X SVGA Driver version %d.%d\n"
			"\t(c) Pascal Bourguignon 1997 <pjb@imaginet.fr>\n",
			[self name],VersionMajor,VersionMinor);
	
		confTab=[deviceDescription configTable];
		dispModeStr=[confTab valueForStringKey:"Display Mode"];
#ifdef DEBUG
		IOLog("%s: After [super init...], Display Mode=\n%s: \"%s\"\n",
				[self name],[self name],dispModeStr);
#endif
		[self _selectMode:dispModeStr];
		[confTab freeString:dispModeStr];
	
		range=[deviceDescription memoryRangeList];
		if(range==0){
			IOLog("%s: No memory range set.\n",[self name]);
			return [super free];
		}
#ifdef DEBUG
		IOLog("%s: range.start=%d range.size=%d\n",
				[self name],range[0].start,range[0].size);
#endif
		videoRamAddress=range[0].start;
	
		displayInfo=[self displayInfo];
		mode=displayInfo->parameters;
	
		displayInfo->frameBuffer =
			(void*)[self mapFrameBufferAtPhysicalAddress:videoRamAddress
				length:range[0].size];
		if(displayInfo->frameBuffer==0){
			IOLog("%s: could not map frame buffer at physical address.\n",
						[self name]);
			return([super free]);
		}
	
		IOLog("%s: Initialized `%s' @ %d Hz.\n",[self name],
							mode->name,displayInfo->refreshRate);

#ifdef DEBUG
		{
			outb(0x3d4,0x48);
			IOLog("%s: CR48=%02x \n",[self name],inb(0x3d5));
			outb(0x3d4,0x4a);
			IOLog("%s: CR4A=%02x \n",[self name],inb(0x3d5));
		}
#endif
		[self _initCounters];
		[self _addUnixHooks:deviceDescription];
		return self;
	}//initFromDeviceDescription:;
	
	
	- setBrightness:(int)level token:(int)t
		/*
			This is from the evScreen protocol. We override our
			superclass on this since it doesn't know how to set
			our brightness.
		*/
	{
		if ( level < EV_SCREEN_MIN_BRIGHTNESS
		|| level > EV_SCREEN_MAX_BRIGHTNESS )
		{
			IOLog("%s: Invalid arg to setBrightness:%d\n",
				[self name],level );
				
			if (level < EV_SCREEN_MIN_BRIGHTNESS) {
				level=EV_SCREEN_MIN_BRIGHTNESS;
			} else {
				level=EV_SCREEN_MAX_BRIGHTNESS;
			}
		}
		SetBrightness(level);
	
		return self;
	}//setBrightness:token:;
	

@end
