#ifndef __CirrusLogicGD754XMode__
#define __CirrusLogicGD754XMode__

/*
	typedef used to store arrays of register index and values.
	-1 as index indicates end of the set...
*/

	typedef struct _SVGAIndexValuePair {
		signed short	index;	// must be 1st field. | for   the 
		unsigned char	value;	// must be 2nd field. | constants
		unsigned char   filler;
	} SVGAIndexValuePair;


/*
	typedef defining a given graphics mode.  A graphics mode
	consists of all the register/value pairs that, when set,
	completely define a mode of operation.
*/
	typedef struct _CirrusLogicGD754XMode {
		const char*                name;  /* human-readable mode name */
		const SVGAIndexValuePair* generalRegisters;
		const SVGAIndexValuePair* sequencerRegisters;
		const SVGAIndexValuePair* crtControllerRegisters;
		const SVGAIndexValuePair* graphicsControllerRegisters;
		const SVGAIndexValuePair* attributeControllerRegisters;
	} CirrusLogicGD754XMode;


#endif
